;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Baseball Disassembly
; This is disassembly of extended sprite 0D in SMW - Baseball
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!Tile = $BE

incsrc EasyPropDefines.txt

!Property = !PaletteC|!SP3SP4

;cape interaction
Print "CAPE",pc
LDA #$03
STA $00
STA $02				;offset

LDA #$01
STA $01
STA $03				;width and height

%ExtendedCapeClipping()
BCC CAPE_RETURN

LDA #$07			;puff of smoke time
STA $176F|!addr,X

LDA #$01			;Change the sprite into a(n extended) puff of smoke.
STA $170B|!addr,x		;

CAPE_RETURN:
RTL

Print "MAIN ",pc
Baseball:
LDA $9D				;stop action when action stopped
BNE .GFX			;

LDA #$02			;speed (x only)
%ExtendedSpeed()		;

LDA $13				;animate every other frame
;AND #$01
;BNE .Interact
LSR
BCS .Interact

INC $1765|!Base2,x		;Frame counter to show animation

.Interact
LDA #$03
STA $00
STA $03

LDA #$01
STA $01
STA $02
%ExtendedHurtCustom()

.GFX
;Some code is shared between Bone and Baseball.
;LDA $170B|!addr,x
;CMP #$0D
;BNE .BoneGFX

;%ExtendedGetDrawInfo()

;unlike many other extended sprites, this one has different offscreen detection. It has boundary detection dedpending on speed, which means if it's moving right, it won't be erased if it's offscreen to the left, only when to the right, and etc.
LDA $171F|!addr,x
SEC
SBC $1A
STA $00

LDA $1733|!addr,x
SBC $1B
BEQ .NotOffscreen
EOR $1747|!addr,x		;if moving right, only right boundary will make it disappear, if moving left, left boundary (otherwise it'll exist indefenitely untill it hits the boundary)
BPL .Offscreen
BMI .Re

.NotOffscreen
LDY .OAMPtr,x

LDA $00				;Tile's X position
STA $0200|!addr,y		;

LDA $1715|!addr,x
SEC
SBC $1C
STA $01

LDA $1729|!addr,x		;as soon as it's vertically offscreen...
SBC $1D
BNE .Offscreen			;erase (though I recall there being GFX wraparound, so maybe it's not perfect?)

LDA $01				;Y position
STA $0201|!Base2,y		;ordinary stuff

LDA #!Tile
STA $0202|!Base2,y		;

LDA $14				;
ASL #4				;
AND #$C0			;do the flips
ORA #$30|!Property		;highest tile priority, palette 8 and SP3/4 page (by default anyway)
STA $0203|!Base2,y		;

TYA				;sprite size = 8x8
LSR #2				;
TAY				;
LDA #$00			;
STA $0420|!Base2,y		;

.Re
RTL				;

.Offscreen
STZ $170B|!addr,x		;erase sprite
RTL

.OAMPtr
db $90,$94,$98,$9C,$A0,$A4,$A8,$AC